/*  Hipparcos ASCII CD-ROM load and search routines Release 1.1 June 1997
    William O'Mullane 
    Astrophysics Division, ESTEC, Noordwijk, The Netherlands. 
    See the readme.pdf file for more information */
#ifndef _hg_notes_H_
#define _hg_notes_H_
#define hg_notes_REC_LEN 99

#include "ihgnotes.h" 

struct hg_notes
{ 
	INT	GN1;
	CHAR	GN2[2];
	CHAR	GN3[2];
	INT	GN4;
	INT	GN5;
	CHAR	GN6[82];
}; /* End Struct */

typedef struct hg_notes hg_notes ;


int print_hg_notes (hg_notes* entry, int decode) ;
int print_hg_notes_cols (hg_notes* entry, int decode) ;
int print_hg_notes_header () ;
FILE* jump_hg_notes (long recNum) ; 
 
int read_hg_notes (FILE* fp,hg_notes* entry) ; 

#define array_hg_notes_size 15
struct array_hg_notes
{
   int no_entries;
   hg_notes data[array_hg_notes_size];
};
typedef struct array_hg_notes array_hg_notes; 
int read_array_hg_notes (int no_entries, array_hg_notes* array);
int print_array_hg_notes (array_hg_notes* array, int decode);
int print_array_hg_notes_cols (array_hg_notes* array, int decode);

FILE* search_hg_notes (INT* key, array_hg_notes* array) ;
#endif /* _hg_notes_H_ */
