/*  Hipparcos ASCII CD-ROM load and search routines Release 1.1 June 1997
    William O'Mullane 
    Astrophysics Division, ESTEC, Noordwijk, The Netherlands. 
    See the readme.pdf file for more information */
#ifndef _hip_dm_o_H_
#define _hip_dm_o_H_
#define hip_dm_o_REC_LEN 339

#include "ihipdm.h" 
#include "dmsa_o.h" 
#include "hg_notes.h" 
#include "hd_notes.h" 
#include "hp_notes.h" 
#include "ihpnotes.h" 
#include "ihdnotes.h" 
#include "ihgnotes.h" 

struct hip_dm_o
{ 
	INT	DO1;
	FLOAT	DO2;
	FLOAT	DO3;
	FLOAT	DO4;
	FLOAT	DO5;
	FLOAT	DO6;
	FLOAT	DO7;
	FLOAT	DO8;
	FLOAT	DO9;
	FLOAT	DO10;
	FLOAT	DO11;
	FLOAT	DO12;
	FLOAT	DO13;
	FLOAT	DO14;
	FLOAT	DO15;
	INT	DO16;
	CHAR	DO17[2];
	CHAR	DOM1[13];
	NONLINEAR	DOM2;
	array_dmsa_o	ORBPARLIT;
	array_hg_notes	HGNOTES;
	array_hd_notes	HDNOTES;
	array_hp_notes	HPNOTES;
}; /* End Struct */

typedef struct hip_dm_o hip_dm_o ;


int print_hip_dm_o (hip_dm_o* entry, int decode) ;
int print_hip_dm_o_cols (hip_dm_o* entry, int decode) ;
int print_hip_dm_o_header () ;
FILE* jump_hip_dm_o (long recNum) ; 
 
int read_hip_dm_o (FILE* fp,hip_dm_o* entry) ; 
FILE* search_hip_dm_o (INT* key, hip_dm_o* arecord) ;
#endif /* _hip_dm_o_H_ */
