/*  Hipparcos ASCII CD-ROM load and search routines Release 1.1 June 1997
    William O'Mullane 
    Astrophysics Division, ESTEC, Noordwijk, The Netherlands. 
    See the readme.pdf file for more information */
#ifndef _hip_dm_v_H_
#define _hip_dm_v_H_
#define hip_dm_v_REC_LEN 146

#include "ihipdm.h" 
#include "hg_notes.h" 
#include "hd_notes.h" 
#include "hp_notes.h" 
#include "ihpnotes.h" 
#include "ihdnotes.h" 
#include "ihgnotes.h" 

struct hip_dm_v
{ 
	INT	DV1;
	FLOAT	DV2;
	FLOAT	DV3;
	FLOAT	DV4;
	FLOAT	DV5;
	FLOAT	DV6;
	FLOAT	DV7;
	FLOAT	DV8;
	FLOAT	DV9;
	FLOAT	DV10;
	FLOAT	DV11;
	CHAR	DV12[2];
	NONLINEAR	DVM1;
	array_hg_notes	HGNOTES;
	array_hd_notes	HDNOTES;
	array_hp_notes	HPNOTES;
}; /* End Struct */

typedef struct hip_dm_v hip_dm_v ;


int print_hip_dm_v (hip_dm_v* entry, int decode) ;
int print_hip_dm_v_cols (hip_dm_v* entry, int decode) ;
int print_hip_dm_v_header () ;
FILE* jump_hip_dm_v (long recNum) ; 
 
int read_hip_dm_v (FILE* fp,hip_dm_v* entry) ; 
FILE* search_hip_dm_v (INT* key, hip_dm_v* arecord) ;
#endif /* _hip_dm_v_H_ */
