/*  Hipparcos ASCII CD-ROM load and search routines Release 1.1 June 1997
    William O'Mullane 
    Astrophysics Division, ESTEC, Noordwijk, The Netherlands. 
    See the readme.pdf file for more information */
#ifndef _hip_dm_x_H_
#define _hip_dm_x_H_
#define hip_dm_x_REC_LEN 24

#include "ihipdm.h" 
#include "hg_notes.h" 
#include "hd_notes.h" 
#include "hp_notes.h" 
#include "ihpnotes.h" 
#include "ihdnotes.h" 
#include "ihgnotes.h" 

struct hip_dm_x
{ 
	INT	DX1;
	FLOAT	DX2;
	FLOAT	DX3;
	CHAR	DX4[3];
	array_hg_notes	HGNOTES;
	array_hd_notes	HDNOTES;
	array_hp_notes	HPNOTES;
}; /* End Struct */

typedef struct hip_dm_x hip_dm_x ;


int print_hip_dm_x (hip_dm_x* entry, int decode) ;
int print_hip_dm_x_cols (hip_dm_x* entry, int decode) ;
int print_hip_dm_x_header () ;
FILE* jump_hip_dm_x (long recNum) ; 
 
int read_hip_dm_x (FILE* fp,hip_dm_x* entry) ; 
FILE* search_hip_dm_x (INT* key, hip_dm_x* arecord) ;
#endif /* _hip_dm_x_H_ */
