/* Index access routines */ 
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "utils.h"

#include "isolar.h" 

int load_idx_solar (char* ifile,idx_solar* index) 
{
/* Routine to load an index from a file. The structure for the index must
 * already exist as must the file of course
 */
   idx_solar idx;
   FILE *fp;
   int i;

   if ( (fp=fopen(ifile,"r"))==NULL)
   {
	fprintf(stderr,"load_idx_solar unable to open %s \n",ifile);
	return (-1);
   }
   if (index == NULL) 
   {
      fprintf (stderr,"load_idx_solar NULL pointer for index\n");
      return (-1);
   }
   /*printf("Loading index idx_solar from %s.. ",ifile);*/
   for (i=0;i<idx_solar_entries;i++)
   {
	if ( (getnext_idx_solar (fp,&index[i])) != 0)
   	{
	   fprintf(stderr,"load_idx_solar problem with entry %d \n",i);
	   break;
	}
   /*     if  ( (i % 5000) == 0) printf("#");*/
   }
   if ( i < idx_solar_entries) 
   {
	fprintf(stderr,"Premature end of index file \n");
   	return -1;
   }
   /* printf(" done \n"); */
   return 0;
} /* End of load_idx_solar*/

int getnext_idx_solar (FILE* fp, idx_solar* entry)
{
   char buffer[idx_solar_REC_LEN + 2];
   if (fgets((char *)&buffer,idx_solar_REC_LEN+1,fp))
   { 
	char delimiter[3]="|\r\0";
	char *token=strtok((char *)&buffer,(char *)&delimiter); 
	strAsINT(token,&entry->NUM);
	token=strtok(NULL,delimiter);
	strAsINT(token,&entry->SEQ_NUM);
	token=strtok(NULL,delimiter);
	strAsINT(token,&entry->HA);
	token=strtok(NULL,delimiter);
	strAsINT(token,&entry->HA_NUM);
	token=strtok(NULL,delimiter);
	strAsINT(token,&entry->HP);
	token=strtok(NULL,delimiter);
	strAsINT(token,&entry->HP_NUM);
	token=strtok(NULL,delimiter);
	strAsINT(token,&entry->T);
	token=strtok(NULL,delimiter);
	strAsINT(token,&entry->T_NUM);
   return 0;
   }
   else
        return -1;
} /* End of getnext_idx_solar */

idx_solar* find_idx_solar (INT* key)
{
   static int init=0;
   static idx_solar index[idx_solar_entries];
   int mid,lpos,rpos,found;
   if (init == 0)
   {
        if (load_idx_solar("solar.idx",(idx_solar*)&index) !=0)
             return NULL;
        init=1;
   }

   /*  Binary search */ 
   rpos = idx_solar_entries; 
   lpos = 0;
   if (rpos > idx_solar_entries) rpos = idx_solar_entries;
   found = 0;
   while (!found && !(lpos==mid && rpos==mid || lpos > rpos))
   {
	mid =  (rpos + lpos) /2;
        found = index[mid].NUM.value == key->value;
     	if (key->value > index[mid].NUM.value )
	   lpos = mid+1;
	else
	   if (key->value < index[mid].NUM.value)
	      rpos = mid;
	/*printf (" %d,%d Betweeen %d,%d and %d,%d Key = %d\n",mid,index[mid].NUM.value,lpos,index[lpos].NUM.value,rpos,index[rpos].NUM.value,key->value);*/
   }
   if (found)
	return &index[mid];
   else
   {
      return NULL;
   }
   
} /* End of find_idx_solar */


